# Copyright (C) 2018 Freetech Solutions

# This file is part of OMniLeads

# This program is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.

# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.

# You should have received a copy of the GNU General Public License
# along with this program.  If not, see http://www.gnu.org/licenses/.
#
---

- name: Include centos variables
  include_vars: group_vars/centos_vars.yml
  tags: always

##########
# Checks #
##########

# Obtengo hostname del nodo
- name: Get the hostname of node
  command: hostname
  register: hostname
  tags: always
  changed_when: false

- set_fact: omni_fqdn="{{ hostname.stdout }}"
  tags: always
  changed_when: false

# Obtengo IP del nodo
- name: Get IP adress of node (selfhosted)
  set_fact: omni_ip={{ hostvars[inventory_hostname]['ansible_' + iface]['ipv4']['address'] }}
  when: iface != "none"
  tags: always

# Obtengo IP publica del nodo
- name: Get public IP address of node
  shell: curl http://ipinfo.io/ip
  register: public_ip
  tags: always

- name: Validate IP public obtained
  shell: if [[ {{ public_ip.stdout }} =~ ^[0-9]+\.[0-9]+\.[0-9]+\.[0-9]+$ ]]; then echo 0; else echo 1; fi
  args:
    executable: /bin/bash
  register: ip_val
  tags: always
  failed_when: false

- fail:
    msg: "The public IP obtained is wrong, check in shell if you obtain a public IP with this command 'curl http://ipinfo.io/ip', after that please run the script again"
  when: ip_val.stdout != '0'
  tags: always

# Comparo si la IP ingresada en el inventory es el mismo  de el nodo
- name: Compare if IP in inventory file is configured in the server
  assert:
    that: "'{{ omni_ip }}' in ansible_all_ipv4_addresses"
    msg: "The IP you inserted in inventory file is wrong, check it"
  when: iface == "none"
  changed_when: false
  tags: always

- name: Get the network/submask configured in default interface
  shell: default_if=$(ip route show | awk '/^default/ {print $5}'); route | grep $default_if|tail -1 |awk -F " " '{print $1"/"$3}'
  register: network_submask
  changed_when: false
  tags: always

# nos aseguramos q' "omni_distribution" esté dentro de los SO permitidos. Si no es asi, esta task generara un error
- name: Print omni_distribution
  debug: msg="omni_distribution es {{ ansible_os_family }}"
  changed_when: false
  when: is_docker == "false"
  tags: always

- name: Check omni_distribution
  fail: msg="omni_distribution con valor {{ ansible_os_family }} es invalida"
  when: ansible_os_family != "RedHat" and is_docker == "false"
  changed_when: false
  tags: always

- name: Check omni_distribution
  shell: awk -F= '/^NAME/{print $2}' /etc/os-release
  register: docker_distribution
  when: is_docker == "true"
  tags: docker_deploy

- name: Check python version inside virtualenv
  shell: "source {{ install_prefix }}virtualenv/bin/activate; python -V"
  register: python_version
  failed_when: false
  tags: postinstall

# Chequeo si la version de asterisk instalada es {{ asterisk_version }}
- name: Check if Asterisk {{ asterisk_version }} is installed
  shell: asterisk -V |awk -F " " '{print $2}'
  changed_when: false
  register: asterisk_installed
  tags: ['asterisk','postinstall']

- name: Check if posgresql-{{ postgresql_version }} is installed
  shell:  bash -lc 'output=`psql -c "SELECT version()"`; if [[ $output == *"{{ postgresql_old_version }}"* ]]; then exit 2; elif [[ $output == *"{{ postgresql_version }}"* ]]; then exit 3; else exit 1; fi'
  failed_when: false
  register: postgresql_new_installed
  tags: ['database','postinstall','docker_deploy']

# Chequeo si la version de rtpengine instalada es {{ rtpengine_version }}
- name: Check if Rtpengine-mr{{ rtpengine_version }} is installed
  shell: rtpengine -v 2>&1 |awk -F "~" '{print $2}'|cut -c 3-
  changed_when: false
  register: rtpengine_installed
  tags: ['kamailio','docker_deploy']

# Chequeo si la version de kamailio instalada es {{ kamailio_version }}
- name: Check if Kamailio {{ kamailio_version }} is installed
  shell: "{{ kamailio_location }}/sbin/kamailio -v |head -1 |awk -F \" \" '{print $3}'"
  changed_when: false
  register: kamailio_installed
  tags: ['kamailio','postinstall']

# Chequeo si el usuario puso sus certificados
- name: Check if trusted certificates exists
  shell: "if [ -z \"$(ls -A /var/tmp/ominicontacto-build/ominicontacto/deploy/certs)\" ]; then exit 1; else exit 0; fi"
  failed_when: false
  changed_when: false
  delegate_to: localhost
  register: trusted_certs_exists
  tags: always

- name: Check if custom and override files for dialplan exists
  shell: "[ -f {{ asterisk_location }}/etc/asterisk/oml_extensions_commonsub_custom.conf ]"
  changed_when: false
  failed_when: false
  delegate_to: localhost
  register: ast_custom_exists
  tags: always

- name: Set name of trusted certificate as ansible variable
  set_fact: "{{ item.var }}={{ item.value }}"
  with_items:
    - { var: cert, value: "{{ trusted_cert }}" }
    - { var: key, value: "{{ trusted_key }}" }
  when: trusted_key is defined and trusted_cert is defined
  tags: always

# Chequeo si el folder de certificado existe
- name: Check if auto-signed certificates folder exists
  shell: "[ -d {{ kamailio_location }}/etc/certs ]"
  changed_when: false
  failed_when: false
  register: certs_exists
  tags: always

- name: Check if $DOCKER_USER was defined previously
  shell: bash -lc 'if [ -z $DOCKER_USER ]; then exit 1; else echo $DOCKER_USER; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_docker_user
  tags: docker_deploy

- set_fact: registry_username="{{ assert_docker_user.stdout }}"
  when: assert_docker_user.rc == 0 and registry_username is not defined
  tags: docker_deploy

- name: Check if $TZ was defined previously
  shell: bash -lc 'if [ -z $TZ ]; then exit 1; else echo $TZ; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_tz
  tags: always

- set_fact: TZ="{{ assert_tz.stdout }}"
  when: assert_tz.rc == 0 and TZ is not defined
  tags: always

- name: Check if $PGUSER was defined previously
  shell: bash -lc 'if [ -z $PGUSER ]; then exit 1; else echo $PGUSER; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_pguser
  tags: always

- set_fact: postgres_user="{{ assert_pguser.stdout }}"
  when: assert_pguser.rc == 0 and postgres_user is not defined
  tags: always

- name: Check if $PGPASSWORD was defined previously
  shell: bash -lc 'if [ -z $PGPASSWORD ]; then exit 1; else echo $PGPASSWORD; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_pgpass
  tags: always

- set_fact: postgres_password="{{ assert_pgpass.stdout }}"
  when: assert_pgpass.rc == 0 and postgres_password is not defined
  tags: always

- name: Check if $AMI_USER was defined previously
  shell: bash -lc 'if [ -z $AMI_USER ]; then exit 1; else echo $AMI_USER; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_amiuser
  tags: always

- set_fact: ami_user="{{ assert_amiuser.stdout }}"
  when: assert_amiuser.rc == 0 and ami_user is not defined
  tags: always

- name: Check if $AMI_PASSWORD was defined previously
  shell: bash -lc 'if [ -z $AMI_PASSWORD ]; then exit 1; else echo $AMI_PASSWORD; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_amipass
  tags: always

- set_fact: ami_password="{{ assert_amipass.stdout }}"
  when: assert_amipass.rc == 0 and ami_password is not defined
  tags: always

- name: Check if $WOMBAT_USER was defined previously
  shell: bash -lc 'if [ -z $WOMBAT_USER ]; then exit 1; else echo $WOMBAT_USER; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_wombatuser
  tags: always

- set_fact: dialer_user="{{ assert_wombatuser.stdout }}"
  when: assert_wombatuser.rc == 0 and dialer_user is not defined
  tags: always

- name: Check if $WOMBAT_PASSWORD was defined previously
  shell: bash -lc 'if [ -z $WOMBAT_PASSWORD ]; then exit 1; else echo $WOMBAT_PASSWORD; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_wombatpass
  tags: always

- set_fact: dialer_password="{{ assert_wombatpass.stdout }}"
  when: assert_wombatpass.rc == 0 and dialer_password is not defined
  tags: always

- name: Check if $DJANGO_PASS was defined previously
  shell: bash -lc 'if [ -z $DJANGO_PASS ]; then exit 1; else echo $DJANGO_PASS; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_djangopass
  tags: always

- set_fact: admin_pass="{{ assert_djangopass.stdout }}"
  when: assert_djangopass.rc == 0 and admin_pass is not defined
  tags: always

- name: Check if $SESSION_COOKIE_AGE was defined previously
  shell: bash -lc 'if [ -z $SESSION_COOKIE_AGE ]; then exit 1; else echo $SESSION_COOKIE_AGE; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_sca
  tags: always

- set_fact: SCA="{{ assert_sca.stdout }}"
  when: assert_sca.rc == 0
  tags: always

- name: Check if $EPHEMERAL_USER_TTL was defined previously
  shell: bash -lc 'if [ -z $EPHEMERAL_USER_TTL ]; then exit 1; else echo $EPHEMERAL_USER_TTL; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_ecctl
  tags: always

- set_fact: ECCTL="{{ assert_ecctl.stdout }}"
  when: assert_ecctl.rc == 0
  tags: always

- name: Check if $MONITORFORMAT was defined previously
  shell: bash -lc 'if [ -z $MONITORFORMAT ]; then exit 1; else echo $MONITORFORMAT; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_monitorformat
  tags: always

- set_fact: MONITORFORMAT="{{ assert_monitorformat.stdout }}"
  when: assert_monitorformat.rc == 0
  tags: always

- name: Check if $MYSQL_PWD was defined previously
  shell: bash -lc 'if [ -z $MYSQL_PWD ]; then exit 1; else echo $MYSQL_PWD; exit 0; fi'
  args:
    executable: /bin/bash
  changed_when: false
  failed_when: false
  register: assert_mysqlpwd
  tags: ['never','postinstall','docker_deploy']

- set_fact: mysql_root_password="{{ assert_mysqlpwd.stdout }}"
  when: assert_mysqlpwd.rc == 0 and mysql_root_password is not defined
  tags: ['never','postinstall','docker_deploy']

- name: Get actual mysql root password
  set_fact: mysql_old_root_password="{{ assert_mysqlpwd.stdout }}"
  when: assert_mysqlpwd.rc == 0
  tags: ['never','postinstall','docker_deploy']

# Chequea si registry_username esta definido
- name: Check if registry_username variable is defined
  fail:
    msg: registry_username variable undefined, edit registry_username variable in inventory file
  when: registry_username is not defined and assert_docker_user.rc == 1 and devenv == 1
  tags: docker_deploy

# Chequea si timezone esta definido
- name: Check if TimeZone variable is defined
  fail:
    msg: TimeZone variable undefined, edit TZ variable in inventory file
  when: TZ is not defined and assert_tz.rc == 1
  tags: always

# Chequea si postgres_user esta definido
- name: Check if postgres user variable is defined
  fail:
    msg: Postgres user undefined, edit postgres_user in inventory file
  when: postgres_user is not defined and assert_pguser.rc == 1
  tags: always

# Chequea si postgres_password esta definido
- name: Check if postgres password variable is defined
  fail:
    msg: Postgres password undefined, edit postgres_password in inventory file
  when: postgres_password is not defined and assert_pgpass.rc == 1
  tags: always

# Chequea si ami_user esta definido
- name: Check if AMI user variable is defined
  fail:
    msg: AMI user undefined, edit ami_user in inventory file
  when: ami_user is not defined and assert_amiuser.rc == 1
  tags: always

# Chequea si ami_password esta definido
- name: Check if AMI password variable is defined
  fail:
    msg: AMI password undefined, edit ami_password in inventory file
  when: ami_password is not defined and assert_amipass.rc == 1
  tags: always

# Chequea si dialer_user esta definido
- name: Check if WD user variable is defined
  fail:
    msg: WD user undefined, edit dialer_user in inventory file
  when: dialer_user is not defined and assert_dialeruser.rc == 1
  tags: always

# Chequea si dialer_password esta definido
- name: Check if WD pass variable is defined
  fail:
    msg: WD pass undefined, edit dialer_password in inventory file
  when: dialer_password is not defined and assert_dialerpass.rc == 1
  tags: always

# Chequea si mysql_root_password esta definido
- name: Check if MYSQL password variable is defined
  fail:
    msg: MYSQL password undefined, edit $mysql_root_password in inventory file
  when: mysql_root_password is not defined and assert_mysqlpwd.rc == 1
  tags: always

# Chequea si web admin password esta definido
- name: Check if web admin password is defined
  fail:
    msg: Web admin variable undefined, edit $admin_pass in inventory file
  when: admin_pass is not defined and assert_djangopass.rc == 1
  tags: always

- name: Set mysql root installed (issabel)
  set_fact: mysql_old_root_password="{{ mysql_root_password }}"
  when: mysql_old_root_password is not defined and docker_distribution.stdout == '"Issabel PBX"'
  tags: ['never', 'docker_deploy']

- set_fact: mysql_old_root_password=""
  when: mysql_old_root_password is not defined and docker_distribution.stdout != '"Issabel PBX"'
  tags: ['never', 'docker_deploy']

- set_fact: mysql_old_root_password=""
  when: mysql_old_root_password is not defined and is_docker == "false"
